--[[
	Title: ULib init

	Opens everything needed by ULib. It handles multiple loadings itself, 
	so you do not need to worry about it.
]]

--- If we haven't already loaded ULib, load it!
if not ULib then
--[[
	Table: ULib

	Contains ULib. Everything in ULib is within this table, and should be used with "ULib." infront of it.
]]
	ULib = {}

	_Msg( "///////////////////////////////\n" )
	_Msg( "//      Ulysses Library      //\n" )
	_Msg( "///////////////////////////////\n" )
	_Msg( "// Loading...                //\n" )

	_OpenScript( "ULib/defines.lua" )
	_Msg( "//  defines.lua              //\n" )
	_OpenScript( "ULib/misc.lua" )
	_Msg( "//  misc.lua                 //\n" )
	_OpenScript( "ULib/util.lua" )
	_Msg( "//  util.lua                 //\n" )
	_OpenScript( "ULib/tables.lua" )
	_Msg( "//  tables.lua               //\n" )
	_OpenScript( "ULib/database.lua" )
	_Msg( "//  database.lua             //\n" )

	_Msg( "//  ULib.db                  //\n" )
--[[
	Table: db

	This database saves every 30 seconds.
]]
	if _file.Exists( ULib.DB_FILE ) then ULib.db = ULib.Database:newFromFile( ULib.DB_FILE )
	else ULib.db = ULib.Database:new() end


--[[
	Function saveDb

	This function saves the database every 30 seconds.
]]
	function ULib.saveDb()
		ULib.db:save( ULib.DB_FILE )
	end
	AddTimer( 30, 0, ULib.saveDb )

	_OpenScript( "ULib/ai.lua" )
	_Msg( "//  ai.lua                   //\n" )
	_OpenScript( "ULib/color.lua" )
	_Msg( "//  color.lua                //\n" )
	_OpenScript( "ULib/concommand.lua" )
	_Msg( "//  concommand.lua           //\n" )
	_OpenScript( "ULib/download.lua" )
	_Msg( "//  download.lua             //\n" )
	_OpenScript( "ULib/entity.lua" )
	_Msg( "//  entity.lua               //\n" )
	_OpenScript( "ULib/menu.lua" )
	_Msg( "//  menu.lua                 //\n" )
	_OpenScript( "ULib/messages.lua" )
	_Msg( "//  messages.lua             //\n" )
	_OpenScript( "ULib/misc.lua" )
	_Msg( "//  misc.lua                 //\n" )
	_OpenScript( "ULib/phys.lua" )
	_Msg( "//  phys.lua                 //\n" )
	_OpenScript( "ULib/player.lua" )
	_Msg( "//  player.lua               //\n" )
	_OpenScript( "ULib/say.lua" )
	_Msg( "//  say.lua                  //\n" )
	_OpenScript( "ULib/ucl.lua" )
	_Msg( "//  ucl.lua                  //\n" )
	_OpenScript( "ULib/vector.lua" )
	_Msg( "//  vector.lua               //\n" )

	_Msg( "// Load Complete!            //\n" )
	_Msg( "///////////////////////////////\n" )
end